<template>
  <form class="card-form" :class="{'card-form--active': !$props.readOnly}"
    @submit.prevent="onFormSubmit">
    <wp-input v-for="field in filteredFields" :key="field.prop"
      :class="[`wp-${(field.span || 12)}`]" v-model="formData[field.prop]"
      :type="field.type" :label="field.label" :modifiers="field.modifiers"
      :readOnly="$props.readOnly" :disabled="!!field.disabled"
      :placeholder="field.placeholder"/>
    <input class="card-form__submit wp-button" v-if="!$props.readOnly"
      type="submit" :value="$props.submitText"/>
  </form>
</template>

<script>
import WpInput from '@/components/WpInput.vue';

export default {
  name: 'CardForm',
  components: {
    WpInput,
  },
  inject: ['switchCreating', 'switchEditing'],
  props: {
    fields: {
      required: true,
      type: Array,
    },
    data: {
      type: Object,
      default: () => {},
    },
    readOnly: {
      type: Boolean,
      default: false,
    },
    submitText: {
      type: String,
      default: 'Сохранить изменения',
    },
    submitFunction: {
      type: Function,
      default: () => {},
    },
  },
  data() {
    return {
      formData: {},
    };
  },
  computed: {
    filteredFields() {
      return this.$props.fields.filter(field => (this.$props.readOnly && !field.editOnly)
        || !this.$props.readOnly);
    },
    isSubmitAllowed() {
      return !this.isChangedDataEmpty;
    },
    isDataEmpty() {
      return !this.$props.data || Object.keys(this.$props.data).length === 0;
    },
    isChangedDataEmpty() {
      return Object.keys(this.changedData).length === 0;
    },
    changedData() {
      if (this.isDataEmpty) return this.formData;
      const result = {};
      this.fields.forEach((field) => {
        if (this.$props.data[field.prop] !== this.formData[field.prop]) {
          result[field.prop] = this.formData[field.prop];
        }
      });
      return result;
    },
  },
  methods: {
    async onFormSubmit() {
      if (!this.isSubmitAllowed) {
        this.switchCreating(false);
        this.switchEditing(false);
        return;
      }
      try {
        const resp = await this.$props.submitFunction(this.changedData);
        this.switchCreating(false);
        this.switchEditing(false);
        this.$toasted.success(resp);
        this.$emit('submit', this.formData);
      } catch (errors) {
        if (errors.length) {
          errors.forEach((err) => {
            this.$toasted.error(err.message);
          });
        } else {
          this.$toasted.error('Неизветсная ошибка');
        }
      }
    },
    resetFormData() {
      this.formData = Object.assign({}, this.$props.data);
    },
  },
  watch: {
    data: {
      immediate: true,
      handler(newVal) {
        if (!newVal) return;
        this.formData = Object.assign({}, newVal);
      },
    },
    readOnly: {
      handler() {
        if (!this.isChangedDataEmpty) this.resetFormData();
      },
    },
  },
};
</script>

<style lang="scss" scoped>
.card-form {
  position: relative;
  display: flex;
  justify-content: flex-start;
  align-items: flex-start;
  flex-wrap: wrap;

  &__submit {
    margin-bottom: 15px;
  }

}
</style>
